Table of Contents

Class: VersionControl | eric3/VCS/VersionControl.py
--- | ---

### Class implementing an abstract base class to be subclassed by all specific VCS interfaces.

It defines the vcs interface to be implemented by subclasses and the common methods.

Base Classes |
--- | ---
QObject

Methods |
--- | ---

__init__ addArguments splitPath startSynchronizedProcess vcsAdd vcsAddBinary vcsAddTree vcsAllRegisteredStates vcsCheckout vcsCleanup vcsCommandLine | vcsCommit vcsDefaultOptions vcsDiff vcsExists vcsExport vcsGetOptions vcsHistory vcsImport vcsInit vcsLog vcsLogin | vcsLogout vcsMerge vcsName vcsRegisteredState vcsRemove vcsRevert vcsSetOptions vcsStatus vcsSwitch vcsTag vcsUpdate

| __init__

    __init__ (
            self,
            parent=None,
            name=None,
            )

### Constructor

#### Arguments

parent
  parent widget (QWidget)
name
  name of this object (string or QString)

| addArguments

    addArguments (
            self,
            proc,
            arglist,
            )

### Private method to add an argument list to the process proc.

#### Arguments

proc
  the process object (QProcess)
arglist
  list of arguments (list of strings or QStrings or a QStringList)

| splitPath

    splitPath ( self,  name )

### Private method splitting name into a directory part and a file part.

#### Arguments

name
  path name (string)

#### Returns

a tuple of 2 strings (dirname, filename).

| startSynchronizedProcess

    startSynchronizedProcess ( self,  proc )

### Private method to start a synchroneous process

This method starts a process and waits for its end while still serving the Qt event loop.

#### Arguments

proc
  process to start (QProcess)

| vcsAdd

    vcsAdd (
            self,
            name,
            isDir=0,
            )

### Public method used to add a file/directory in the vcs.

It must not return anything.

#### Arguments

name
  file/directory name to be added (string)
isDir
  flag indicating name is a directory (boolean)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsAddBinary

    vcsAddBinary (
            self,
            name,
            isDir=0,
            )

### Public method used to add a file/directory in binary mode in the vcs.

It must not return anything.

#### Arguments

name
  file/directory name to be added (string)
isDir
  flag indicating name is a directory (boolean)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsAddTree

    vcsAddTree ( self,  path )

### Public method to add a directory tree rooted at path in the vcs.

It must not return anything.

#### Arguments

path
  root directory of the tree to be added (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsAllRegisteredStates

    vcsAllRegisteredStates (
            self,
            names,
            dname,
            )

### Public method used to get the registered states of a number of files in the vcs.

#### Arguments

names
  dictionary with all filenames to be checked as keys
dname
  directory to check in (string)

#### Returns

the received dictionary completed with a combination of canBeCommited and canBeAdded or None in order to signal an error

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsCheckout

    vcsCheckout (
            self,
            vcsDir,
            project,
            projectDir,
            noDialog=0,
            tag=None,
            )

### Public method used to check the project out of the vcs.

It must return a boolean to indicate an execution without errors.

#### Arguments

vcsDir
  name of the VCS directory (string)
project
  reference to the project object
projectDir
  project directory to create (string)
noDialog
  flag indicating quiet operations
tag
  tag of version to check out (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsCleanup

    vcsCleanup ( self,  name )

### Public method used to cleanup the local copy.

#### Arguments

name
  directory name to be cleaned up (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsCommandLine

    vcsCommandLine ( self,  name )

### Public method used to execute arbitrary vcs commands.

#### Arguments

name
  directory name of the working directory (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsCommit

    vcsCommit (
            self,
            name,
            message,
            noDialog=0,
            )

### Public method used to make the change of a file/directory permanent in the vcs.

It must return a boolean to indicate an execution without errors.

#### Arguments

name
  file/directory name to be committed (string)
message
  message for this operation (string)
noDialog
  flag indicating quiet operations

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsDefaultOptions

    vcsDefaultOptions ( self )

### Public method used to retrieve the default options for the vcs.

#### Returns

a dictionary with the vcs operations as key and the respective options as values. The key `global` must contain the global options. The other keys must be `commit`, `update`, `add`, `remove`, `diff`, `log`, `history`, `tag`, `status` and `export`.

| vcsDiff

    vcsDiff ( self,  name )

### Public method used to view the diff of a file/directory in the vcs.

It must not return anything.

#### Arguments

name
  file/directory name to be diffed (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsExists

    vcsExists ( self )

### Public method used to test for the presence of the vcs.

It must return a bool to indicate the existance.

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsExport

    vcsExport (
            self,
            vcsDir,
            project,
            projectDir,
            tag=None,
            )

### Public method used to export a directory from the vcs.

It must return a boolean to indicate an execution without errors.

#### Arguments

vcsDir
  name of the VCS directory (string)
project
  reference to the project object
projectDir
  project directory to create (string)
tag
  tag of version to check out (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsGetOptions

    vcsGetOptions ( self )

### Public method used to retrieve the options of the vcs.

#### Returns

a dictionary of option strings that can be passed to vcsSetOptions.

| vcsHistory

    vcsHistory ( self,  name )

### Public method used to view the history of a file/directory in the vcs.

It must not return anything.

#### Arguments

name
  file/directory name to show the history for (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsImport

    vcsImport (
            self,
            vcsDir,
            message,
            project,
            vendor,
            release,
            projectDir,
            noDialog=0,
            )

### Public method used to import the project into the vcs.

It must return a boolean to indicate an execution without errors.

#### Arguments

vcsDir
  name of the VCS directory (string)
message
  message for this operation (string)
project
  reference to the project object
vendor
  vendor string (string)
release
  release version string (string)
projectDir
  project directory to create (string)
noDialog
  flag indicating quiet operations

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsInit

    vcsInit (
            self,
            vcsDir,
            noDialog=0,
            )

### Public method used to initialize the vcs.

It must return a boolean to indicate an execution without errors.

#### Arguments

vcsDir
  name of the VCS directory (string)
noDialog
  flag indicating quiet operations (boolean)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsLog

    vcsLog ( self,  name )

### Public method used to view the log of a file/directory in the vcs.

It must not return anything.

#### Arguments

name
  file/directory name to show the log for (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsLogin

    vcsLogin (
            self,
            user,
            passwd,
            host,
            repository,
            )

### Public method used to login to the remote repository.

It must not return anything.

#### Arguments

user
  user name (string)
passwd
  password (string)
host
  hostname (string)
repository
  repository name (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsLogout

    vcsLogout (
            self,
            user,
            host,
            repository,
            )

### Public method used to logout from the remote repository.

It must not return anything.

#### Arguments

user
  user name (string)
host
  hostname (string)
repository
  repository name (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsMerge

    vcsMerge ( self,  name )

### Public method used to merge a tag/branch into the local project.

It must not return anything.

#### Arguments

name
  file/directory name to be merged (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsName

    vcsName ( self )

### Public method returning the name of the vcs.

#### Returns

name of the vcs (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsRegisteredState

    vcsRegisteredState ( self,  name )

### Public method used to get the registered state of a file in the vcs.

#### Arguments

name
  filename to check (string)

#### Returns

a combination of canBeCommited and canBeAdded or 0 in order to signal an error

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsRemove

    vcsRemove (
            self,
            name,
            project=0,
            )

### Public method used to add a file/directory in the vcs.

#### Arguments

name
  file/directory name to be removed (string)
project
  flag indicating deletion of a project tree (boolean)

#### Returns

flag indicating successfull operation (boolean)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsRevert

    vcsRevert ( self,  name )

### Public method used to revert changes made to a file/directory.

It must not return anything.

#### Arguments

name
  file/directory name to be reverted (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsSetOptions

    vcsSetOptions ( self,  options )

### Public method used to set the options for the vcs.

#### Arguments

options
  a dictionary of option strings with keys as defined by the default options

| vcsStatus

    vcsStatus ( self,  name )

### Public method used to view the status of a file/directory in the vcs.

It must not return anything.

#### Arguments

name
  file/directory name to show the status for (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsSwitch

    vcsSwitch ( self,  name )

### Public method used to switch a directory to a different tag/branch.

It must not return anything.

#### Arguments

name
  directory name to be switched (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsTag

    vcsTag ( self,  name )

### Public method used to set the tag of a file/directory in the vcs.

It must not return anything.

#### Arguments

name
  file/directory name to be tagged (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

| vcsUpdate

    vcsUpdate ( self,  name )

### Public method used to update a file/directory in the vcs.

It must not return anything.

#### Arguments

name
  file/directory name to be updated (string)

Exceptions |
--- | ---
RuntimeError, 'Not implemented'

Table of Contents

This document was automatically generated by HappyDoc version 2.1